
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Payment_requestsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const payment_requests = await db.payment_requests.create(
            {
                id: data.id || undefined,
        
        request_number: data.request_number
        ||
        null
            ,
            
        requested_amount: data.requested_amount
        ||
        null
            ,
            
        currency: data.currency
        ||
        null
            ,
            
        payment_method: data.payment_method
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        requested_at: data.requested_at
        ||
        null
            ,
            
        justification: data.justification
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await payment_requests.setOrganization(currentUser.organization.id || null, {
            transaction,
        });
        
        await payment_requests.setInvoice( data.invoice || null, {
            transaction,
        });
        
        await payment_requests.setRequested_by_user( data.requested_by_user || null, {
            transaction,
        });
        

        

        

        return payment_requests;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const payment_requestsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                request_number: item.request_number
            ||
            null
            ,
            
                requested_amount: item.requested_amount
            ||
            null
            ,
            
                currency: item.currency
            ||
            null
            ,
            
                payment_method: item.payment_method
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                requested_at: item.requested_at
            ||
            null
            ,
            
                justification: item.justification
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const payment_requests = await db.payment_requests.bulkCreate(payment_requestsData, { transaction });

        // For each item created, replace relation files
        

        return payment_requests;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const payment_requests = await db.payment_requests.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.request_number !== undefined) updatePayload.request_number = data.request_number;
        
        
        if (data.requested_amount !== undefined) updatePayload.requested_amount = data.requested_amount;
        
        
        if (data.currency !== undefined) updatePayload.currency = data.currency;
        
        
        if (data.payment_method !== undefined) updatePayload.payment_method = data.payment_method;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.requested_at !== undefined) updatePayload.requested_at = data.requested_at;
        
        
        if (data.justification !== undefined) updatePayload.justification = data.justification;
        
        
        updatePayload.updatedById = currentUser.id;

        await payment_requests.update(updatePayload, {transaction});

        
        
        if (data.organization !== undefined) {
            await payment_requests.setOrganization(
              
              (globalAccess ? data.organization : currentUser.organization.id),
              
              { transaction }
            );
        }
        
        if (data.invoice !== undefined) {
            await payment_requests.setInvoice(
              
              data.invoice,
              
              { transaction }
            );
        }
        
        if (data.requested_by_user !== undefined) {
            await payment_requests.setRequested_by_user(
              
              data.requested_by_user,
              
              { transaction }
            );
        }
        

        
        

        

        return payment_requests;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const payment_requests = await db.payment_requests.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of payment_requests) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of payment_requests) {
                await record.destroy({transaction});
            }
        });


        return payment_requests;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const payment_requests = await db.payment_requests.findByPk(id, options);

        await payment_requests.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await payment_requests.destroy({
            transaction
        });

        return payment_requests;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const payment_requests = await db.payment_requests.findOne(
            { where },
            { transaction },
        );

        if (!payment_requests) {
            return payment_requests;
        }

        const output = payment_requests.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.payments_payment_request = await payment_requests.getPayments_payment_request({
            transaction
        });
        
        
        
        
        
        
        
        output.organization = await payment_requests.getOrganization({
            transaction
        });
        
        
        output.invoice = await payment_requests.getInvoice({
            transaction
        });
        
        
        output.requested_by_user = await payment_requests.getRequested_by_user({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.organizations,
        as: 'organization',
        
      },

      {
        model: db.invoices,
        as: 'invoice',
        
        where: filter.invoice ? {
          [Op.or]: [
            { id: { [Op.in]: filter.invoice.split('|').map(term => Utils.uuid(term)) } },
            {
              invoice_number: {
                [Op.or]: filter.invoice.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'requested_by_user',
        
        where: filter.requested_by_user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.requested_by_user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.requested_by_user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.request_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'payment_requests',
                        'request_number',
                        filter.request_number,
                    ),
                };
            }
            
            if (filter.justification) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'payment_requests',
                        'justification',
                        filter.justification,
                    ),
                };
            }
            

            
            

            
            if (filter.requested_amountRange) {
                const [start, end] = filter.requested_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    requested_amount: {
                    ...where.requested_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    requested_amount: {
                    ...where.requested_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.requested_atRange) {
                const [start, end] = filter.requested_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    requested_at: {
                    ...where.requested_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    requested_at: {
                    ...where.requested_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.currency) {
                where = {
                    ...where,
                currency: filter.currency,
            };
            }
            
            if (filter.payment_method) {
                where = {
                    ...where,
                payment_method: filter.payment_method,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      
      if (filter.organization) {
        const listItems = filter.organization.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationId: {[Op.or]: listItems}
        };
      }
      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.payment_requests.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'payment_requests',
                        'request_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.payment_requests.findAll({
            attributes: [ 'id', 'request_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['request_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.request_number,
        }));
    }

    
};

